extern double StopLoss   = 1000;     // SL   
extern double TakeProfit = 50;       //    

extern string  = " :";
extern double Lots       = 0;     //   . 
extern double K          = 0.1;

extern string BABO = "BABO:";
extern double P = 12;
extern double M = 1;


extern string KELT = ":";
extern double MA   = 20;
extern double ATR  = 20;
extern double MP   = 2;

extern string  = ":";
extern double CODA = 0;
extern double Pips = 0;
extern double  =200;
extern double PERIOD = 0;
extern double I =0;

extern double TrailingStop = 2;
extern double BUY =1;
extern double SELL =1;
extern double CS =1;
extern double CB =1;

int start()
{
   int ticket = 0;

   double Lts,
          Min_Lot,
          SL,
          TP;

   bool Cls_B = false,
        Cls_S = false,
        Opn_B = false,
        Opn_S = false,
        Opn_BO = false,
        Opn_SO = false;

   for(int i = I; i < OrdersTotal(); i++)
   {
      if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderSymbol() != Symbol()) continue;
      if(OrderType() > OP_SELL) continue;

      ticket = OrderTicket();
      break;
   }

   // 
   if(ticket > 0)
   {
      if(OrderType() == OP_SELL) 
      {
         if(TrailingStop > 0)
         {
            if(OrderOpenPrice() - Ask >= (TrailingStop + Pips) * Point)
            {
               if(OrderStopLoss() > (Ask + Point * TrailingStop))
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, 
                        OrderClosePrice() - OrderTakeProfit() * Point - TrailingStop * Point, 0, CLR_NONE);
               }
            }
         }
      }
      else
      if(OrderType() == OP_BUY)
      {
         if(TrailingStop > 0)
         {
            if(Bid - OrderOpenPrice() >= (TrailingStop + Pips) * Point)
            {
               if(OrderStopLoss() < (Bid - Point * TrailingStop))
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop,
                        OrderClosePrice() + OrderTakeProfit() * Point + TrailingStop * Point, 0, CLR_NONE);
               }
            }
         }
      }
   }

   //  



   double diClose1 = iClose(NULL, 1, 1);

   double C  = iMA(NULL, 1, 1, 0, MODE_SMA,PRICE_CLOSE, 0);
  
   double KU = iCustom(NULL,PERIOD, "", MA, ATR,MP, 0, 0);
   double KL = iCustom(NULL,PERIOD, "", MA, ATR,MP, 2, 0);
   double KM = iCustom(NULL,PERIOD, "", MA, ATR,MP, 1, 0);
  
   double B = iCustom(NULL,PERIOD,"BABO",P,M,0,2,0);
   double B1 = iCustom(NULL,PERIOD,"BABO",P,M,0,2,1);
   double B2 = iCustom(NULL,PERIOD,"BABO",P,M,0,2,2);
   double B5 = iCustom(NULL,5,"BABO",P,M,0,2,0);
   double B51 = iCustom(NULL,5,"BABO",P,M,0,2,1);
  
   if(B>B1&&B1<B2&&C<KL)
   {
    Opn_B = true;           
   }
   if(B>B1&&B1<B2&&C<KL&&CS==1)
   {
    Cls_S = true;            
   }

   //...............................................................................      

   if(B<B1&&B1>B2&&C>KU)
   {
    Opn_S = true;         
   }
   if(B<B1&&B1>B2&&C>KU&&CB==1)
   {
    Cls_B = true;         
   }

   //................................................................................

   if(iBarShift(NULL, 1440, OrderOpenTime()) > 0 && CODA == 1)
   {
      Cls_B = true;
      Cls_S = true;
   }

   //  
   if(ticket > 0)
      while(true)
      {
         if(OrderType() == OP_BUY && Cls_B == true)
         {
            RefreshRates();
            if(OrderClose(ticket, OrderLots(), OrderClosePrice(), 2))
            {
               Alert("  Buy ", ticket);
               break;
            }

            if(Fun_Error(GetLastError()) == 1)
               continue;

            return;
         }

         if(OrderType() == OP_SELL && Cls_S == true)
         {
            RefreshRates();
            if(OrderClose(ticket, OrderLots(), OrderClosePrice(), 2))
            {
               Alert("  Sell ", ticket);
               break;
            }

            if(Fun_Error(GetLastError()) == 1)
               continue;

            return;
         }

         break;
      }

   //+------------------------------------------------------------------+
   //  
   RefreshRates();
   Min_Lot = MarketInfo(Symbol(), MODE_MINLOT);

   if(Lots > 0 && K == 0)
      Lts = Lots;
   if(K > 0)
      Lts = * K * AccountFreeMargin() / 150000;

   if(Lts > 100)
      Lts = 100;

   if(Lts < Min_Lot) Lts = Min_Lot;

   //  
   //+------------------------------------------------------------------+
   while(true)
   {
      if(ticket == 0 && Opn_B == true&&BUY ==1)
      {
         RefreshRates();
         SL = Bid - New_Stop(StopLoss) * Point;
         TP = Bid + New_Stop(TakeProfit) * Point;
         Alert("  Buy.  ..");
         ticket = OrderSend(Symbol(), OP_BUY, Lts, Ask, 2, SL,TP);

         if(ticket == 0)
         {
            Alert("  Buy ", ticket);
            return;
         }

         if(Fun_Error(GetLastError()) == 1)
            continue;

         return;
      }

      if(ticket == 0 && Opn_S == true&&SELL==1)
      {
         RefreshRates();
         SL = Ask + New_Stop(StopLoss) * Point;
         TP = Ask - New_Stop(TakeProfit) * Point;
         Alert("  Sell.  ..");
         ticket = OrderSend(Symbol(), OP_SELL, Lts, Bid, 2, SL, TP);

         if(ticket > 0)
         {
            Alert("  Sell ", ticket);
            return;
         }

         if(Fun_Error(GetLastError()) == 1)
            continue;

         return;
      }

      break;
   }

   return;
}
  
int Fun_Error(int Error)
{
   switch(Error)
   {
      case 4:
         Alert("  .   ..");
         Sleep(3000);
         return(1);
      case 135:
         Alert(" .   ..");
         RefreshRates();
         return(1);
      case 136:
         Alert(" .   ..");
         while(RefreshRates() == false)
            Sleep(1);
         return(1);
      case 137:
         Alert(" .   ..");
         Sleep(3000);
         return(1);
      case 146:
         Alert("  .  ..");
         Sleep(500);
         return(1);
      case 2:
         Alert(" .");
         return(0);
   }
}

int New_Stop(int Parameter)
{
   int Min_Dist = MarketInfo(Symbol(), MODE_STOPLEVEL);
   if(Parameter < Min_Dist)
   {
      Parameter = Min_Dist; 
      Alert("  -."); 
   }

   return(Parameter);
}